## libselinux 1.12

=== src/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib

LIBVERSION = 1


LIBA=libselinux.a 
TARGET=libselinux.so
LIBSO=$(TARGET).$(LIBVERSION)
OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
CFLAGS = -Wall
override CFLAGS += -I../include 

all: $(LIBA) $(LIBSO)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	ranlib $@

$(LIBSO): $(LOBJS)
	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO) 
	ln -sf $@ $(TARGET) 

%.o:  %.c policy.h
	$(CC) $(CFLAGS) -c -o $@ $<

%.lo:  %.c policy.h
	$(CC) $(CFLAGS) -fPIC -c -o $@ $<

install: all
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

clean: 
	rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET)

## libselinux 1.18

=== Makefile ===
all: 
	$(MAKE) -C src 
	$(MAKE) -C utils

install: 
	$(MAKE) -C include install
	$(MAKE) -C src install
	$(MAKE) -C utils install
	$(MAKE) -C man install

relabel:

clean:
	$(MAKE) -C src clean
	$(MAKE) -C utils clean

=== src/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
 LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
 CFLAGS = -Wall
-override CFLAGS += -I../include 
+override CFLAGS += -I../include -D_GNU_SOURCE
 
 all: $(LIBA) $(LIBSO)
 
@@ -21,14 +21,14 @@
 	ranlib $@
 
 $(LIBSO): $(LOBJS)
-	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO) 
+	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),-z,defs
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c policy.h
 	$(CC) $(CFLAGS) -c -o $@ $<
 
 %.lo:  %.c policy.h
-	$(CC) $(CFLAGS) -fPIC -c -o $@ $<
+	$(CC) $(CFLAGS) -fpic -DSHARED -c -o $@ $<
 
 install: all
 	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)

=== utils/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
BINDIR ?= $(PREFIX)/bin

CFLAGS = -Wall
override CFLAGS += -I../include
LDLIBS += -L../src -lselinux 

TARGETS=$(patsubst %.c,%,$(wildcard *.c))

all: $(TARGETS)

install: all
	-mkdir -p $(BINDIR)
	install -m 755 $(TARGETS) $(BINDIR)

clean:
	rm -f $(TARGETS) *.o 

relabel:

## libselinux 1.22

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,8 @@
 	$(MAKE) -C utils install
 	$(MAKE) -C man install
 
-relabel:
+relabel: 
+	$(MAKE) -C src relabel
 
 clean:
 	$(MAKE) -C src clean

=== include/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
INCDIR ?= $(PREFIX)/include/selinux

install:
	test -d $(INCDIR) || install -m 755 -d $(INCDIR)
	install -m 644 $(wildcard selinux/*.h) $(INCDIR)

=== src/Makefile ===
--- 
+++ 
@@ -11,14 +11,15 @@
 LIBSO=$(TARGET).$(LIBVERSION)
 OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
 LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
-CFLAGS = -Wall
-override CFLAGS += -I../include -D_GNU_SOURCE
+CFLAGS = -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
+override CFLAGS += -I../include -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
+RANLIB=ranlib
 
 all: $(LIBA) $(LIBSO)
 
 $(LIBA):  $(OBJS)
 	$(AR) rcs $@ $^
-	ranlib $@
+	$(RANLIB) $@
 
 $(LIBSO): $(LOBJS)
 	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),-z,defs
@@ -37,6 +38,9 @@
 	install -m 755 $(LIBSO) $(SHLIBDIR)
 	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)
 
+relabel:
+	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)
+
 clean: 
 	rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET)

=== utils/Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
 # Installation directories.
 PREFIX ?= $(DESTDIR)/usr
-BINDIR ?= $(PREFIX)/bin
+BINDIR ?= $(PREFIX)/sbin
 
 CFLAGS = -Wall
-override CFLAGS += -I../include
+override CFLAGS += -I../include -D_GNU_SOURCE
 LDLIBS += -L../src -lselinux 
 
 TARGETS=$(patsubst %.c,%,$(wildcard *.c))

## libselinux 1.24

=== src/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	$(RANLIB) $@
 
 $(LIBSO): $(LOBJS)
-	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),-z,defs
+	$(CC) $(LDFLAGS) -shared -o $@ $^ -ldl -Wl,-soname,$(LIBSO),-z,defs
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c policy.h

## libselinux 1.28

=== src/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib
INCLUDEDIR ?= $(PREFIX)/include
PYLIBVER ?= python2.4
PYINC ?= /usr/include/$(PYLIBVER)
PYLIB ?= /usr/lib/$(PYLIBVER)
PYTHONLIBDIR ?= $(LIBDIR)/$(PYLIBVER)

LIBVERSION = 1

LIBA=libselinux.a 
TARGET=libselinux.so
SWIGIF= selinuxswig.i
SWIGCOUT= selinuxswig_wrap.c
SWIGLOBJ:= $(patsubst %.c,%.lo,$(SWIGCOUT)) 
SWIGSO=_selinux.so
SWIGFILES=$(SWIGSO) selinux.py 
LIBSO=$(TARGET).$(LIBVERSION)
OBJS= $(patsubst %.c,%.o,$(filter-out $(SWIGCOUT),$(wildcard *.c))) 
LOBJS= $(patsubst %.c,%.lo,$(filter-out $(SWIGCOUT),$(wildcard *.c)))
CFLAGS ?= -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
RANLIB=ranlib

SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./

all: $(LIBA) $(LIBSO) $(SWIGSO)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(SWIGLOBJ): $(SWIGCOUT)
	$(CC) $(CFLAGS) -I$(PYINC) -fpic -DSHARED -c -o $@ $<

$(SWIGSO): $(SWIGLOBJ)
	$(CC) $(LDFLAGS) -shared -o $@ $< -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@

$(LIBSO): $(LOBJS)
	$(CC) $(LDFLAGS) -shared -o $@ $^ -ldl -lsepol -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs
	ln -sf $@ $(TARGET) 

%.o:  %.c policy.h
	$(CC) $(CFLAGS) -c -o $@ $<

%.lo:  %.c policy.h
	$(CC) $(CFLAGS) -fpic -DSHARED -c -o $@ $<

$(SWIGCOUT): $(SWIGIF)
	$(SWIG) $^

swigify: $(SWIGIF)
	$(SWIG) $^

install: all install-pywrap
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

install-pywrap: 
	test -d $(PYTHONLIBDIR)/site-packages || install -m 755 -d $(PYTHONLIBDIR)/site-packages
	install -m 755 $(SWIGFILES) $(PYTHONLIBDIR)/site-packages

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET)

=== utils/Makefile ===
--- 
+++ 
@@ -1,10 +1,11 @@
 # Installation directories.
 PREFIX ?= $(DESTDIR)/usr
+LIBDIR ?= $(PREFIX)/lib
 BINDIR ?= $(PREFIX)/sbin
 
-CFLAGS = -Wall
+CFLAGS ?= -Wall
 override CFLAGS += -I../include -D_GNU_SOURCE
-LDLIBS += -L../src -lselinux 
+LDLIBS += -L../src -lselinux -lsepol -L$(LIBDIR)
 
 TARGETS=$(patsubst %.c,%,$(wildcard *.c))

## libselinux 1.30

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,18 @@
 all: 
 	$(MAKE) -C src 
 	$(MAKE) -C utils
+
+pywrap: 
+	$(MAKE) -C src pywrap
 
 install: 
 	$(MAKE) -C include install
 	$(MAKE) -C src install
 	$(MAKE) -C utils install
 	$(MAKE) -C man install
+
+install-pywrap: 
+	$(MAKE) -C src install-pywrap 
 
 relabel: 
 	$(MAKE) -C src relabel

=== src/Makefile ===
--- 
+++ 
@@ -26,7 +26,9 @@
 
 SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./
 
-all: $(LIBA) $(LIBSO) $(SWIGSO)
+all: $(LIBA) $(LIBSO) 
+
+pywrap: $(SWIGSO)
 
 $(LIBA):  $(OBJS)
 	$(AR) rcs $@ $^
@@ -39,7 +41,7 @@
 	$(CC) $(LDFLAGS) -shared -o $@ $< -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@
 
 $(LIBSO): $(LOBJS)
-	$(CC) $(LDFLAGS) -shared -o $@ $^ -ldl -lsepol -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs
+	$(CC) $(LDFLAGS) -shared -o $@ $^ -ldl -lsepol -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs,-z,relro
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c policy.h
@@ -54,14 +56,14 @@
 swigify: $(SWIGIF)
 	$(SWIG) $^
 
-install: all install-pywrap
+install: all 
 	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
 	install -m 644 $(LIBA) $(LIBDIR)
 	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
 	install -m 755 $(LIBSO) $(SHLIBDIR)
 	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)
 
-install-pywrap: 
+install-pywrap: pywrap
 	test -d $(PYTHONLIBDIR)/site-packages || install -m 755 -d $(PYTHONLIBDIR)/site-packages
 	install -m 755 $(SWIGFILES) $(PYTHONLIBDIR)/site-packages

## libselinux 1.32

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,13 @@
 relabel: 
 	$(MAKE) -C src relabel
 
-clean:
-	$(MAKE) -C src clean
+clean distclean:
+	$(MAKE) -C src $@
 	$(MAKE) -C utils clean
 
+indent:
+	$(MAKE) -C src $@
+	$(MAKE) -C utils $@
+	$(MAKE) -C include $@
+
+test:

=== include/Makefile ===
--- 
+++ 
@@ -5,3 +5,7 @@
 install:
 	test -d $(INCDIR) || install -m 755 -d $(INCDIR)
 	install -m 644 $(wildcard selinux/*.h) $(INCDIR)
+
+indent:
+	../../Lindent $(wildcard selinux/*.h)
+

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 LIBDIR ?= $(PREFIX)/lib
 SHLIBDIR ?= $(DESTDIR)/lib
 INCLUDEDIR ?= $(PREFIX)/include
-PYLIBVER ?= python2.4
+PYLIBVER ?= $(shell python -c 'import sys;print "python%d.%d" % sys.version_info[0:2]')
 PYINC ?= /usr/include/$(PYLIBVER)
 PYLIB ?= /usr/lib/$(PYLIBVER)
 PYTHONLIBDIR ?= $(LIBDIR)/$(PYLIBVER)
@@ -24,11 +24,18 @@
 override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
 RANLIB=ranlib
 
+ARCH := $(patsubst i%86,i386,$(shell uname -m))
+ifneq (,$(filter i386,$(ARCH)))
+TLSFLAGS += -mno-tls-direct-seg-refs
+endif
+
 SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./
+
+GENERATED=$(SWIGCOUT)
 
 all: $(LIBA) $(LIBSO) 
 
-pywrap: $(SWIGSO)
+pywrap: all $(SWIGSO)
 
 $(LIBA):  $(OBJS)
 	$(AR) rcs $@ $^
@@ -45,7 +52,7 @@
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c policy.h
-	$(CC) $(CFLAGS) -c -o $@ $<
+	$(CC) $(CFLAGS) $(TLSFLAGS) -c -o $@ $<
 
 %.lo:  %.c policy.h
 	$(CC) $(CFLAGS) -fpic -DSHARED -c -o $@ $<
@@ -73,3 +80,9 @@
 clean: 
 	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) 
 
+distclean: clean
+	rm -f $(SWIGCOUT) $(SWIGFILES)
+
+indent:
+	../../Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))
+

=== utils/Makefile ===
--- 
+++ 
@@ -18,5 +18,8 @@
 clean:
 	rm -f $(TARGETS) *.o 
 
+indent:
+	../../Lindent $(wildcard *.[ch])
+
 relabel:

## libselinux 2.0.15

=== src/Makefile ===
--- 
+++ 
@@ -42,7 +42,7 @@
 	$(RANLIB) $@
 
 $(SWIGLOBJ): $(SWIGCOUT)
-	$(CC) $(CFLAGS) -I$(PYINC) -fpic -DSHARED -c -o $@ $<
+	$(CC) $(CFLAGS) -I$(PYINC) -fPIC -DSHARED -c -o $@ $<
 
 $(SWIGSO): $(SWIGLOBJ)
 	$(CC) $(LDFLAGS) -shared -o $@ $< -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@
@@ -55,7 +55,7 @@
 	$(CC) $(CFLAGS) $(TLSFLAGS) -c -o $@ $<
 
 %.lo:  %.c policy.h
-	$(CC) $(CFLAGS) -fpic -DSHARED -c -o $@ $<
+	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<
 
 $(SWIGCOUT): $(SWIGIF)
 	$(SWIG) $^
@@ -84,5 +84,5 @@
 	rm -f $(SWIGCOUT) $(SWIGFILES)
 
 indent:
-	../../Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))
+	../../scripts/Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))

=== utils/Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 	rm -f $(TARGETS) *.o 
 
 indent:
-	../../Lindent $(wildcard *.[ch])
+	../../scripts/Lindent $(wildcard *.[ch])
 
 relabel:

## libselinux 2.0.55

=== include/Makefile ===
--- 
+++ 
@@ -7,5 +7,5 @@
 	install -m 644 $(wildcard selinux/*.h) $(INCDIR)
 
 indent:
-	../../Lindent $(wildcard selinux/*.h)
+	../../scripts/Lindent $(wildcard selinux/*.h)

=== utils/Makefile ===
--- 
+++ 
@@ -4,10 +4,17 @@
 BINDIR ?= $(PREFIX)/sbin
 
 CFLAGS ?= -Wall
-override CFLAGS += -I../include -D_GNU_SOURCE
-LDLIBS += -L../src -lselinux -lsepol -L$(LIBDIR)
+override CFLAGS += -I../include -D_GNU_SOURCE $(EMFLAGS)
+LDLIBS += -L../src -lselinux -L$(LIBDIR)
 
 TARGETS=$(patsubst %.c,%,$(wildcard *.c))
+ifeq ($(DISABLE_AVC),y)
+	UNUSED_TARGETS+=compute_av compute_create compute_member compute_relabel
+endif
+ifeq ($(DISABLE_BOOL),y)
+	UNUSED_TARGETS+=getsebool togglesebool
+endif
+TARGETS:= $(filter-out $(UNUSED_TARGETS), $(TARGETS))
 
 all: $(TARGETS)

## libselinux 2.0.65-maemo1

=== src/Makefile ===
# Installation directories.
PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib
INCLUDEDIR ?= $(PREFIX)/include
PYLIBVER ?= $(shell python -c 'import sys;print "python%d.%d" % sys.version_info[0:2]')
PYINC ?= /usr/include/$(PYLIBVER)
PYLIB ?= /usr/lib/$(PYLIBVER)
PYTHONLIBDIR ?= $(LIBDIR)/$(PYLIBVER)

LIBVERSION = 1

LIBA=libselinux.a 
TARGET=libselinux.so
LIBPC=libselinux.pc
SWIGIF= selinuxswig_python.i
SWIGCOUT= selinuxswig_wrap.c
SWIGLOBJ:= $(patsubst %.c,%.lo,$(SWIGCOUT)) 
SWIGSO=_selinux.so
SWIGFILES=$(SWIGSO) selinux.py 
LIBSO=$(TARGET).$(LIBVERSION)
AUDIT2WHYSO=audit2why.so

ifeq ($(DISABLE_AVC),y)
	UNUSED_SRCS+=avc.c avc_internal.c avc_sidtab.c mapping.c stringrep.c checkAccess.c
endif
ifeq ($(DISABLE_BOOL),y)
	UNUSED_SRCS+=booleans.c
endif
ifeq ($(DISABLE_RPM),y)
	UNUSED_SRCS+=rpm.c
endif
SRCS= $(filter-out $(UNUSED_SRCS), $(filter-out audit2why.c $(SWIGCOUT),$(wildcard *.c)))

OBJS= $(patsubst %.c,%.o,$(SRCS))
LOBJS= $(patsubst %.c,%.lo,$(SRCS))
CFLAGS ?= -Werror -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 $(EMFLAGS)
RANLIB=ranlib

ARCH := $(patsubst i%86,i386,$(shell uname -m))
ifneq (,$(filter i386,$(ARCH)))
TLSFLAGS += -mno-tls-direct-seg-refs
endif

SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./

GENERATED=$(SWIGCOUT)

all: $(LIBA) $(LIBSO) $(LIBPC)

pywrap: all $(SWIGSO) $(AUDIT2WHYSO)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(SWIGLOBJ): $(SWIGCOUT)
	$(CC) $(filter-out -Werror,$(CFLAGS)) -I$(PYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGSO): $(SWIGLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $< -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@

$(LIBSO): $(LOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs,-z,relro
	ln -sf $@ $(TARGET) 

$(LIBPC): $(LIBPC).in
	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBDIR):; s:@includedir@:$(INCLUDEDIR):' < $< > $@

audit2why.lo: audit2why.c
	$(CC) $(CFLAGS) -I$(PYINC) -fPIC -DSHARED -c -o $@ $<

$(AUDIT2WHYSO): audit2why.lo
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lselinux ${LIBDIR}/libsepol.a -L$(LIBDIR) -Wl,-soname,$@

%.o:  %.c policy.h
	$(CC) $(CFLAGS) $(TLSFLAGS) -c -o $@ $<

%.lo:  %.c policy.h
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

$(SWIGCOUT): $(SWIGIF)
	$(SWIG) $^

swigify: $(SWIGIF)
	$(SWIG) $^

install: all $(LIBPC)
	test -d $(DESTDIR)$(LIBDIR) || install -m 755 -d $(DESTDIR)$(LIBDIR)
	install -m 644 $(LIBA) $(DESTDIR)$(LIBDIR)
	test -d $(DESTDIR)$(LIBDIR)/pkgconfig || install -m 755 -d $(DESTDIR)$(LIBDIR)/pkgconfig
	install -m 644 $(LIBPC) $(DESTDIR)$(LIBDIR)/pkgconfig
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	cd $(DESTDIR)$(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

install-pywrap: pywrap
	test -d                         $(DESTDIR)$(PYTHONLIBDIR)/site-packages/selinux  || \
          install -m 755 -d             $(DESTDIR)$(PYTHONLIBDIR)/site-packages/selinux 
	install   -m 755 $(SWIGSO)      $(DESTDIR)$(PYTHONLIBDIR)/site-packages/selinux
	install   -m 755 $(AUDIT2WHYSO) $(DESTDIR)$(PYTHONLIBDIR)/site-packages/selinux
	install   -m 644 selinux.py     $(DESTDIR)$(PYTHONLIBDIR)/site-packages/selinux/__init__.py

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) $(LIBPC) $(AUDIT2WHYSO) *.o *.lo *~

distclean: clean
	rm -f $(SWIGCOUT) $(SWIGFILES)

indent:
	../../scripts/Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))

=== debian/changelog ===
libselinux (2.0.65-maemo1) unstable; urgency=high

  * fix to compile for maemo

 -- Thomas Maass <inyourface@gmx.de>  Sat, 26 Jun 2010 20:29:00 +0200

libselinux (2.0.65-5) unstable; urgency=high

  * Bug fix: "Python errors during upgrade", thanks to Frans Pop
    This is a serious bug.                              (Closes: #499086).
  * mount point /selinux does not exist. Fixed, though I believe it should
    go into base-files. But we need the fix for lenny, and I am not
    interested in bug-pong.                             (Closes: #498010)
  * Updated Standards-Version: No changes required.

 -- Manoj Srivastava <srivasta@debian.org>  Tue, 16 Sep 2008 00:51:17 -0500

libselinux (2.0.65-4) unstable; urgency=high

  * Set urgency=high for Lenny

 -- Russell Coker <russell@coker.com.au>  Sat, 02 Aug 2008 15:52:31 +1000

libselinux (2.0.65-3) unstable; urgency=low

  * Added patch from Josselin Mouette to fix build problem.
    Closes: #493316

 -- Russell Coker <russell@coker.com.au>  Sat, 02 Aug 2008 15:46:31 +1000

libselinux (2.0.65-2) unstable; urgency=low

  * Added exec_prefix to libselinux.pc.
    Closes: #489724

 -- Russell Coker <russell@coker.com.au>  Sat, 12 Jul 2008 10:24:02 +1000

libselinux (2.0.65-1) unstable; urgency=low

  * Non-maintainer upload.
  * New release needed for the latest policy.

 -- Russell Coker <russell@coker.com.au>  Sat, 12 Jul 2008 00:02:04 +1000

libselinux (2.0.59-1) unstable; urgency=high

  * New upstream release
    * Merged new X label "poly_selection" namespace from Eamon Walsh.
    * Merged reset_selinux_config() for load policy from Dan Walsh.
    * Merged avc_has_perm() errno fix from Eamon Walsh.
    * Regenerated Flask headers from refpolicy flask definitions.
    * Merged compute_member AVC function and manpages from Eamon Walsh.
    * Provide more error reporting on load policy failures from Stephen Smalley.
    * Merged new X label "poly_prop" namespace from Eamon Walsh.
    * Disable setlocaldefs if no local boolean or users files are present
      from Stephen Smalley. 
    * Skip userspace preservebools processing for Linux >= 2.6.22 from
      Stephen Smalley. 
    * Merged fix for audit2why from Dan Walsh.
    * Merged audit2why python binding from Dan Walsh.
    * Merged updated swig bindings from Dan Walsh, including typemap for pid_t.
    * Fix for the avc:  granted null message bug from Stephen Smalley.
    * matchpathcon(8) man page update from Dan Walsh.
    * dlopen libsepol.so.1 rather than libsepol.so from Stephen Smalley.
    * Based on a suggestion from Ulrich Drepper, defer regex compilation
      until we have a stem match, by Stephen Smalley. 
      A further optimization would be to defer regex compilation until we
      have a complete match of the constant prefix of the regex - TBD. 
    * Regenerated Flask headers from policy.
    * AVC enforcing mode override patch from Eamon Walsh.
    * Aligned attributes in AVC netlink code from Eamon Walsh.
    * Merged refactored AVC netlink code from Eamon Walsh.
    * Merged new X label namespaces from Eamon Walsh.
    * Bux fix and minor refactoring in string representation code.
    * Merged selinux_get_callback, avc_open, empty string mapping from
      Eamon Walsh. 
    * Fix segfault resulting from missing file_contexts file.
  * Bug fix: "libselinux: selinux_default_type_path implicitly converted
    to pointer", thanks to dann frazier . Closed by the new upstream
    release.                                                  (Closes: #465287).

 -- Manoj Srivastava <srivasta@debian.org>  Mon, 17 Mar 2008 16:30:52 -0500

libselinux (2.0.35-1) unstable; urgency=low

  * New upstream release
    * Make netlink socket close-on-exec to avoid descriptor leakage from
      Dan Walsh. 
    * Pass CFLAGS when using gcc for linking from Dennis Gilmore. 
    * Fix selabel option flag setting for 64-bit from Stephen Smalley.
    * Re-map a getxattr return value of 0 to a getfilecon return value of
      -1 with errno EOPNOTSUPP from Stephen Smalley. 
    * Fall back to the compat code for security_class_to_string and
      security_av_perm_to_string from Stephen Smalley. 
    * Fix swig binding for rpm_execcon from James Athey.
    * Fix file_contexts.homedirs path from Todd Miller.
    * Fix segfault resulting from uninitialized print-callback pointer.
    * Added x_contexts path function patch from Eamon Walsh.
    * Fix build for EMBEDDED=y from Yuichi Nakamura.
    * Fix markup problems in selinux man pages from Dan Walsh.
    * Updated av_permissions.h and flask.h to include new nscd permissions
      from Dan Walsh. 
    * Added swigify to top-level Makefile from Dan Walsh.
    * Fix for string_to_security_class segfault on x86_64 from Stephen
      Smalley.
    * Fix for getfilecon() for zero-length contexts from Stephen Smalley.
    * Refactored SWIG bindings from James Athey.
    * Labeling and callback interface patches from Eamon Walsh.
    * Class and permission mapping support patches from Eamon Walsh.
    * Object class discovery support patches from Chris PeBenito.
    * Refactoring and errno support in string representation code.
    * Merged patch to reduce size of libselinux and remove need for
      libsepol for embedded systems from Yuichi Nakamura. 
      This patch also turns the link-time dependency on libsepol into a
      runtime (dlopen) dependency even in the non-embedded case. 
    * Updated Lindent script and reindented two header files.
    * Merged additional swig python bindings from Dan Walsh.
  * When selinux_init_load_policy calls mount() it "knows" when selinux is
    not wanted due to being disabled or having no kernel device handle and
    sets *enforce to 0, but still allows the following fprintf to display
    a rather misleading error message. The solution was provided by  Kel
    Modderman, but has been refactored slightly.
                                             Closes: Bug#424011, Bug#447762


=== debian/control ===
Source: libselinux
VCS-Arch: http://arch.debian.org/arch/private/srivasta/grab/libselinux
VCS-Browser: http://arch.debian.org/cgi-bin/archzoom.cgi/srivasta@debian.org--lenny/libselinux?expand
Priority: optional
Section: libs
Maintainer: Thomas Maass <inyourface@gmx.de>
Standards-Version: 3.8.0.0
Build-Depends: file, libsepol1-dev (>= 2.0.25), python-all-dev (>= 2.3.5-11), swig
XS-Python-Version: >= 2.4

Package: selinux-utils
Architecture: any
Section: admin
Depends: ${shlibs:Depends}
Description: SELinux utility programs
 This package provides various utility programs for a Security-enhanced
 Linux system. Security-enhanced Linux is a patch of the Linux kernel
 and a number of utilities with enhanced security functionality
 designed to add mandatory access controls to Linux. This package
 provides utility programs to get and set process and file security
 contexts and to obtain security policy decisions.

Package: libselinux1
Architecture: any
Section: libs
Priority: required
Depends: ${shlibs:Depends}
Description: SELinux shared libraries
 This package provides the shared libraries for Security-enhanced
 Linux. Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.
 .
 libselinux1 provides an API for SELinux applications to get and set
 process and file security contexts and to obtain security policy
 decisions.  Required for any applications that use the SELinux API.


Package: libselinux1-dev
Architecture: any
Depends: ${shlibs:Depends},  libselinux1 (= ${binary:Version}), libsepol1-dev (>= 1.12)
Section: libdevel
Provides: libselinux-dev
Conflicts: libselinux-dev
Description: SELinux development headers
 This package provides the  static libraries and header files
 needed for developing SELinux applications.  Security-enhanced Linux
 is a patch of the Linux kernel and a number of utilities with
 enhanced security functionality designed to add mandatory access
 controls to Linux.  The Security-enhanced Linux kernel contains new
 architectural components originally developed to improve the security
 of the Flask operating system. These architectural components provide
 general support for the enforcement of many kinds of mandatory access
 control policies, including those based on the concepts of Type
 Enforcement, Role-based Access Control, and Multi-level Security.

Package: python-selinux
Architecture: any
Depends: ${shlibs:Depends}, ${python:Depends}, python-support (>= 0.7.1)
Section: python
Conflicts: python2.4-selinux (<= 1.30-1), libselinux-dev (<= 1.28-1)
Replaces: python2.4-selinux, libselinux-dev
Provides: ${python:Provides}
Description: Python bindings to SELinux shared libraries
 This package provides the Python bindings needed for developing Python 
 SELinux applications.  Security-enhanced Linux is a patch of the
 Linux kernel and a number of utilities with enhanced security
 functionality designed to add mandatory access controls to Linux.
 The Security-enhanced Linux kernel contains new architectural
 components originally developed to improve the security of the Flask
 operating system. These architectural components provide general
 support for the enforcement of many kinds of mandatory access control
 policies, including those based on the concepts of Type Enforcement,
 Role-based Access Control, and Multi-level Security.

=== debian/watch ===
# format version number, currently 2; this line is compulsory!
version=2

http://www.nsa.gov/selinux/code/download-trunk.cfm ../archives/libselinux-(.*)\.tgz
#http://www.nsa.gov/selinux/archives/libselinux-(.*)\.tgz

## libselinux 2.0.85

=== src/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib
INCLUDEDIR ?= $(PREFIX)/include
PYLIBVER ?= $(shell python -c 'import sys;print "python%d.%d" % sys.version_info[0:2]')
PYINC ?= /usr/include/$(PYLIBVER)
PYLIB ?= /usr/lib/$(PYLIBVER)
PYTHONLIBDIR ?= $(LIBDIR)/$(PYLIBVER)
RUBYLIBVER ?= $(shell ruby -e 'print RUBY_VERSION.split(".")[0..1].join(".")')
RUBYPLATFORM ?= $(shell ruby -e 'print RUBY_PLATFORM')
RUBYINC ?= $(LIBDIR)/ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)

LIBVERSION = 1

LIBA=libselinux.a 
TARGET=libselinux.so
SWIGIF= selinuxswig_python.i
SWIGRUBYIF= selinuxswig_ruby.i
SWIGCOUT= selinuxswig_wrap.c
SWIGRUBYCOUT= selinuxswig_ruby_wrap.c
SWIGLOBJ:= $(patsubst %.c,%.lo,$(SWIGCOUT)) 
SWIGRUBYLOBJ:= $(patsubst %.c,%.lo,$(SWIGRUBYCOUT)) 
SWIGSO=_selinux.so
SWIGFILES=$(SWIGSO) selinux.py 
SWIGRUBYSO=_rubyselinux.so
LIBSO=$(TARGET).$(LIBVERSION)
AUDIT2WHYSO=audit2why.so

ifeq ($(DISABLE_AVC),y)
	UNUSED_SRCS+=avc.c avc_internal.c avc_sidtab.c mapping.c stringrep.c checkAccess.c
endif
ifeq ($(DISABLE_BOOL),y)
	UNUSED_SRCS+=booleans.c
endif
ifeq ($(DISABLE_RPM),y)
	UNUSED_SRCS+=rpm.c
endif

GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT)
SRCS= $(filter-out $(UNUSED_SRCS), $(filter-out audit2why.c $(GENERATED),$(wildcard *.c)))

OBJS= $(patsubst %.c,%.o,$(SRCS))
LOBJS= $(patsubst %.c,%.lo,$(SRCS))
CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 $(EMFLAGS)
RANLIB=ranlib

ARCH := $(patsubst i%86,i386,$(shell uname -m))
ifneq (,$(filter i386,$(ARCH)))
TLSFLAGS += -mno-tls-direct-seg-refs
endif

SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./

SWIGRUBY = swig -Wall -ruby -o $(SWIGRUBYCOUT) -outdir ./

all: $(LIBA) $(LIBSO) 

pywrap: all $(SWIGSO) $(AUDIT2WHYSO)

rubywrap: all $(SWIGRUBYSO)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(SWIGLOBJ): $(SWIGCOUT)
	$(CC) $(filter-out -Werror,$(CFLAGS)) -I$(PYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGRUBYLOBJ): $(SWIGRUBYCOUT)
	$(CC) $(filter-out -Werror,$(CFLAGS)) -I$(RUBYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGSO): $(SWIGLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $< -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@

$(SWIGRUBYSO): $(SWIGRUBYLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@

$(LIBSO): $(LOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs,-z,relro
	ln -sf $@ $(TARGET) 

audit2why.lo: audit2why.c
	$(CC) $(CFLAGS) -I$(PYINC) -fPIC -DSHARED -c -o $@ $<

$(AUDIT2WHYSO): audit2why.lo
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lselinux ${LIBDIR}/libsepol.a -L$(LIBDIR) -Wl,-soname,$@

%.o:  %.c policy.h
	$(CC) $(CFLAGS) $(TLSFLAGS) -c -o $@ $<

%.lo:  %.c policy.h
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

$(SWIGCOUT): $(SWIGIF)
	$(SWIG) $^

$(SWIGRUBYCOUT): $(SWIGRUBYIF)
	$(SWIGRUBY) $^

swigify: $(SWIGIF)
	$(SWIG) $^

install: all 
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

install-pywrap: pywrap
	test -d $(PYTHONLIBDIR)/site-packages/selinux || install -m 755 -d $(PYTHONLIBDIR)/site-packages/selinux
	install -m 755 $(SWIGSO) $(PYTHONLIBDIR)/site-packages/selinux
	install -m 755 $(AUDIT2WHYSO) $(PYTHONLIBDIR)/site-packages/selinux
	install -m 644  selinux.py $(PYTHONLIBDIR)/site-packages/selinux/__init__.py

install-rubywrap: rubywrap
	test -d $(RUBYINSTALL) || install -m 755 -d $(RUBYINSTALL) 
	install -m 755 $(SWIGRUBYSO) $(RUBYINSTALL)/selinux.so

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) $(AUDIT2WHYSO) *.o *.lo *~

distclean: clean
	rm -f $(GENERATED) $(SWIGFILES)

indent:
	../../scripts/Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))

## libselinux 2.0.89

=== src/Makefile ===
--- 
+++ 
@@ -12,18 +12,20 @@
 RUBYINC ?= $(LIBDIR)/ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
 RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
 
+VERSION = $(shell cat ../VERSION)
 LIBVERSION = 1
 
 LIBA=libselinux.a 
 TARGET=libselinux.so
-SWIGIF= selinuxswig_python.i
+LIBPC=libselinux.pc
+SWIGIF= selinuxswig_python.i selinuxswig_python_exception.i
 SWIGRUBYIF= selinuxswig_ruby.i
 SWIGCOUT= selinuxswig_wrap.c
 SWIGRUBYCOUT= selinuxswig_ruby_wrap.c
 SWIGLOBJ:= $(patsubst %.c,%.lo,$(SWIGCOUT)) 
 SWIGRUBYLOBJ:= $(patsubst %.c,%.lo,$(SWIGRUBYCOUT)) 
 SWIGSO=_selinux.so
-SWIGFILES=$(SWIGSO) selinux.py 
+SWIGFILES=$(SWIGSO) selinux.py selinuxswig_python_exception.i
 SWIGRUBYSO=_rubyselinux.so
 LIBSO=$(TARGET).$(LIBVERSION)
 AUDIT2WHYSO=audit2why.so
@@ -56,7 +58,7 @@
 
 SWIGRUBY = swig -Wall -ruby -o $(SWIGRUBYCOUT) -outdir ./
 
-all: $(LIBA) $(LIBSO) 
+all: $(LIBA) $(LIBSO) $(LIBPC)
 
 pywrap: all $(SWIGSO) $(AUDIT2WHYSO)
 
@@ -82,6 +84,12 @@
 	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs,-z,relro
 	ln -sf $@ $(TARGET) 
 
+$(LIBPC): $(LIBPC).in
+	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBDIR):; s:@includedir@:$(INCLUDEDIR):' < $< > $@
+
+selinuxswig_python_exception.i: ../include/selinux/selinux.h
+	sh exception.sh > $@ 
+
 audit2why.lo: audit2why.c
 	$(CC) $(CFLAGS) -I$(PYINC) -fPIC -DSHARED -c -o $@ $<
 
@@ -101,13 +109,15 @@
 	$(SWIGRUBY) $^
 
 swigify: $(SWIGIF)
-	$(SWIG) $^
+	$(SWIG) $<
 
 install: all 
 	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
 	install -m 644 $(LIBA) $(LIBDIR)
 	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
 	install -m 755 $(LIBSO) $(SHLIBDIR)
+	test -d $(LIBDIR)/pkgconfig || install -m 755 -d $(LIBDIR)/pkgconfig
+	install -m 644 $(LIBPC) $(LIBDIR)/pkgconfig
 	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)
 
 install-pywrap: pywrap
@@ -124,7 +134,7 @@
 	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)
 
 clean: 
-	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) $(AUDIT2WHYSO) *.o *.lo *~
+	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) $(AUDIT2WHYSO) *.o *.lo *~
 
 distclean: clean
 	rm -f $(GENERATED) $(SWIGFILES)

## libselinux 2.0.96

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,36 @@
+DISABLE_AVC ?= n
+DISABLE_SETRANS ?= n
+DISABLE_RPM ?= n
+DISABLE_BOOL ?= n
+ifeq ($(EMBEDDED),y)
+	override DISABLE_AVC=y
+	override DISABLE_SETRANS=y
+	override DISABLE_RPM=y
+	override DISABLE_BOOL=y
+endif
+ifeq ($(DISABLE_AVC),y)
+	EMFLAGS+= -DDISABLE_AVC
+endif
+ifeq ($(DISABLE_BOOL),y)
+	EMFLAGS+= -DDISABLE_BOOL
+endif
+ifeq ($(DISABLE_SETRANS),y)
+	EMFLAGS+= -DDISABLE_SETRANS
+endif
+export DISABLE_AVC DISABLE_SETRANS DISABLE_RPM DISABLE_BOOL EMFLAGS
+
 all: 
 	$(MAKE) -C src 
 	$(MAKE) -C utils
 
+swigify: all
+	$(MAKE) -C src swigify
+
 pywrap: 
 	$(MAKE) -C src pywrap
+
+rubywrap: 
+	$(MAKE) -C src rubywrap
 
 install: 
 	$(MAKE) -C include install
@@ -13,6 +40,9 @@
 
 install-pywrap: 
 	$(MAKE) -C src install-pywrap 
+
+install-rubywrap: 
+	$(MAKE) -C src install-rubywrap 
 
 relabel: 
 	$(MAKE) -C src relabel

=== src/Makefile ===
--- 
+++ 
@@ -11,6 +11,7 @@
 RUBYPLATFORM ?= $(shell ruby -e 'print RUBY_PLATFORM')
 RUBYINC ?= $(LIBDIR)/ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
 RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
+LIBBASE=$(shell basename $(LIBDIR))
 
 VERSION = $(shell cat ../VERSION)
 LIBVERSION = 1
@@ -85,10 +86,10 @@
 	ln -sf $@ $(TARGET) 
 
 $(LIBPC): $(LIBPC).in
-	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBDIR):; s:@includedir@:$(INCLUDEDIR):' < $< > $@
+	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBBASE):; s:@includedir@:$(INCLUDEDIR):' < $< > $@
 
 selinuxswig_python_exception.i: ../include/selinux/selinux.h
-	sh exception.sh > $@ 
+	bash exception.sh > $@ 
 
 audit2why.lo: audit2why.c
 	$(CC) $(CFLAGS) -I$(PYINC) -fPIC -DSHARED -c -o $@ $<

## libselinux 2.1.0

=== debian/changelog ===
libselinux (2.1.0-4) unstable; urgency=low

  * Put /selinux back in libselinux1
    Closes: #647035

 -- Russell Coker <russell@coker.com.au>  Mon, 31 Oct 2011 13:50:56 +1100

libselinux (2.1.0-3) unstable; urgency=low

  * Accept Kyle's changes.
    Closes: #645121
  * Merge Steve McIntyre's patch for cross compilation.
    Closes: #630626
  * Use two paragraphs for long description.
    Closes: #637369

 -- Russell Coker <russell@coker.com.au>  Fri, 28 Oct 2011 23:17:30 +1100

libselinux (2.1.0-2) UNRELEASED; urgency=low

  * Move manpages for privileged commands "setenforce" and "togglesebool" to
    section 8 where they belong.
  * Fix other manpages which refer to "selinuxenabled" and "getenforce" to
    find them in section 1.
  * Convert to Debian source format "3.0 (quilt)".  This allows us to break
    apart the changes-to-upstream into multiple patches with descriptions.
    - fix-makefile-bugs.patch
    - fix-manpages.patch
    - hide-library-destructors.patch
  * Change "Architecture" to "linux-any" to reflect build requirements.
  * Completely rewrite Debian packaging to use debhelper.  This has a very
    positive effect on the build time (97 sec => 64 sec) and dramatically
    reduces the size of the packaging metadata:
      46 files changed, 441 insertions(+), 2833 deletions(-)
    Note that half of the inserted lines are the new broken-out patches.
  * Comply with new Ruby packaging conventions (using gem2deb/dh_ruby)
    - Rename ruby package to "ruby-selinux"
    - Add support for ruby1.9.1
  * Comply with new Python packaging conventions (use dh_python2)

 -- Kyle Moffett <Kyle.D.Moffett@boeing.com>  Thu, 13 Oct 2011 13:25:54 -0400

libselinux (2.1.0-1) unstable; urgency=low

  * New upstream release
  * Add symbols fini_selinuxmnt selinux_file_context_subs_dist_path
    selinux_status_close selinux_status_deny_unknown selinux_status_getenforce
    selinux_status_open selinux_status_policyload selinux_status_updated
  * Remove symbol selabelsublist which should never have been exported (it
    couldn't be used by outside code).
  * Made myself the maintainer as Manoj has been busy with paid work.
  * Made it build-depend on the latest libsepol1-dev.

 -- Russell Coker <russell@coker.com.au>  Tue, 30 Aug 2011 14:33:45 +1000

libselinux (2.0.98-1.1) unstable; urgency=low

  * Non-maintainer upload with permission of the maintainer.
  * Build for multiarch, setting Pre-Depends multiarch-support in our shared
    lib package.
  * Always use -n with gzip, to avoid encoding timestamps in the gzip file;
    this ensures compressed docs and other files are identical across
    multiple builds, required for multiarch.

 -- Steve Langasek <vorlon@debian.org>  Tue, 21 Jun 2011 07:24:02 +0000

libselinux (2.0.98-1) unstable; urgency=low

  * New upstream release
    + Turn off default user handling when computing user contexts by Dan Walsh
    + Thread local storage fixes from Eamon Walsh.
  * Added myself to the uploaders and changed the source URL.
  * Made selabelsublist optional in the libselinux1.symbols file, it was
    supposed to be private and there seems no possibility that anyone could
    have used it without causing a crash so there seems no harm in removing it.

 -- Russell Coker <russell@coker.com.au>  Thu, 31 Mar 2011 23:14:03 +1100

libselinux (2.0.96-1) unstable; urgency=low

  * New upstream release
    + Add const qualifiers to public API where appropriate by KaiGai
      Kohei.
    + Remove duplicate slashes in paths in selabel_lookup from Chad Sellers
    + Adds a chcon method to the libselinux python bindings from Steve Lawrence

 -- Manoj Srivastava <srivasta@debian.org>  Tue, 20 Jul 2010 23:27:20 -0700

libselinux (2.0.94-1) unstable; urgency=low

  * New upstream release
    * Set errno=EINVAL for invalid contexts from Dan Walsh.
    * Show strerror for security_getenforce() by Colin Walters.
    * Merged selabel database support by KaiGai Kohei.
    * Modify netlink socket blocking code by KaiGai Kohei.
    * Fix from Eric Paris to fix leak on non-selinux systems.
    * regenerate swig wrappers
    * pkgconfig fix to respect LIBDIR from Dan Walsh.
    * Change the AVC to only audit the permissions specified by the
      policy, excluding any permissions specified via dontaudit or not
      specified via auditallow.
    * Fix compilation of label_file.c with latest glibc headers.
    * add/reformat man pages by Guido Trentalancia <guido@trentalancia.com>.
    * Change exception.sh to be called with bash by Manoj Srivastava
      <srivasta@debian.org>
  * Bug fix: "memory leak", thanks to Sam Hocevar. Upstream fixed bug
    a wee bit differently.                              (Closes: #570639).


 -- Manoj Srivastava <srivasta@debian.org>  Sun, 28 Mar 2010 08:40:37 -0700

libselinux (2.0.89-4) unstable; urgency=low

  * Revert decision not to ship /selinux; instead, ask policy folks to add
    an exception.                                Closes: #496752

 -- Manoj Srivastava <srivasta@debian.org>  Fri, 20 Nov 2009 13:00:47 -0600

libselinux (2.0.89-3) unstable; urgency=low

  * Fix breakage in python-selinux.

 -- Manoj Srivastava <srivasta@debian.org>  Thu, 19 Nov 2009 23:58:10 -0600

libselinux (2.0.89-2) unstable; urgency=low

  * [libselinux 16a76cd]: Do not ship /selinux
    Shipping /selinux is a violation of the FHS, and is proscribed by
    Debian policy. There is nothing that actually depends on /selinux
    being present, possibly apart from user scripts. From this point on,
    the machine operator will have to decide where to locate the mount
    point for selinuxfs, and modify /etc/fstab accordingly. SELinux
    modules scan for selinuxfs in /proc/mounts, so everything should
    adjust to the location of the selinuxfs mount automatically.
    Bug fix: "/selinux not in FHS", thanks to Kees Cook (Closes: #556972).

 -- Manoj Srivastava <srivasta@debian.org>  Thu, 19 Nov 2009 01:16:30 -0600

libselinux (2.0.89-1) unstable; urgency=low



=== debian/control ===
Source: libselinux
VCS-Git: git://git.debian.org/~srivasta/debian/libselinux.git
VCS-Browser: http://git.debian.org/git/?p=users/srivasta/debian/libselinux.git
Priority: optional
Section: libs
Maintainer: Russell Coker <russell@coker.com.au>
Uploaders: Manoj Srivastava <srivasta@debian.org>
Standards-Version: 3.9.2
Build-Depends: file, libsepol1-dev (>= 2.1.0), python-all-dev (>= 2.6.6-3~),
               swig, gem2deb (>= 0.2.7~), pkg-config, debhelper (>= 8.1.3~)
X-Python-Version: >= 2.4
XS-Ruby-Versions: ruby1.8 ruby1.9.1

Package: selinux-utils
Architecture: linux-any
Section: admin
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SELinux utility programs
 This package provides various utility programs for a Security-enhanced
 Linux system. Security-enhanced Linux is a patch of the Linux kernel
 and a number of utilities with enhanced security functionality
 designed to add mandatory access controls to Linux. This package
 provides utility programs to get and set process and file security
 contexts and to obtain security policy decisions.

Package: libselinux1
Architecture: linux-any
Priority: required
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SELinux runtime shared libraries
 This package provides the shared libraries for Security-enhanced
 Linux that provides interfaces (e.g. library functions for the
 SELinux kernel APIs like getcon(), other support functions like
 getseuserbyname()) to SELinux-aware applications. Security-enhanced
 Linux is a patch of the Linux kernel and a number of utilities with
 enhanced security functionality designed to add mandatory access
 controls to Linux.  The Security-enhanced Linux kernel contains new
 architectural components originally developed to improve the security
 of the Flask operating system. These architectural components provide
 general support for the enforcement of many kinds of mandatory access
 control policies, including those based on the concepts of Type
 Enforcement, Role-based Access Control, and Multi-level Security.
 .
 libselinux1 provides an API for SELinux applications to get and set
 process and file security contexts and to obtain security policy
 decisions.  Required for any applications that use the SELinux
 API. libselinux may use the shared libsepol to manipulate the binary
 policy if necessary (e.g. to downgrade the policy format to an older
 version supported by the kernel) when loading policy.


Package: libselinux1-dev
Architecture: linux-any
Depends: ${misc:Depends}, libselinux1 (= ${binary:Version}),
 libsepol1-dev (>= 1.12)
Section: libdevel
Provides: libselinux-dev
Conflicts: libselinux-dev
Description: SELinux development headers
 This package provides the  static libraries and header files
 needed for developing SELinux applications.  Security-enhanced Linux
 is a patch of the Linux kernel and a number of utilities with
 enhanced security functionality designed to add mandatory access
 controls to Linux.  The Security-enhanced Linux kernel contains new
 architectural components originally developed to improve the security
 of the Flask operating system. These architectural components provide
 general support for the enforcement of many kinds of mandatory access
 control policies, including those based on the concepts of Type
 Enforcement, Role-based Access Control, and Multi-level Security.


Package: ruby-selinux
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}, ruby | ruby-interpreter
Section: ruby
Conflicts: libselinux-ruby1.8 (<= 2.1.0-1)
Replaces: libselinux-ruby1.8 (<= 2.1.0-1)
Provides: libselinx-ruby1.8
Description: Ruby bindings to SELinux shared libraries
 This package provides the Ruby bindings needed for developing Ruby
 SELinux applications.  Security-enhanced Linux is a patch of the
 Linux kernel and a number of utilities with enhanced security
 functionality designed to add mandatory access controls to Linux.
 The Security-enhanced Linux kernel contains new architectural
 components originally developed to improve the security of the Flask
 operating system. These architectural components provide general
 support for the enforcement of many kinds of mandatory access control
 policies, including those based on the concepts of Type Enforcement,
 Role-based Access Control, and Multi-level Security.

## Transitional package
Package: libselinux-ruby1.8
Section: oldlibs
Architecture: all
Depends: ${misc:Depends}, ruby-selinux
Description: Transitional package for ruby-selinux
 This is a transitional package to ease upgrades to the ruby-selinux
 package.  It can be safely removed when nothing else depends on it.

Package: python-selinux
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Section: python
Conflicts: python2.4-selinux (<= 1.30-1), libselinux-dev (<= 1.28-1)
Replaces: python2.4-selinux, libselinux-dev
Provides: ${python:Provides}
Description: Python bindings to SELinux shared libraries
 This package provides the Python bindings needed for developing Python
 SELinux applications.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a number
 of utilities with enhanced security functionality designed to add mandatory
 access controls to Linux. The Security-enhanced Linux kernel contains
 new architectural components originally developed to improve the security
 of the Flask operating system. These architectural components provide
 general support for the enforcement of many kinds of mandatory access
 control policies, including those based on the concepts of Type Enforcement,
 Role-based Access Control, and Multi-level Security.

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

## Figure out some variables
DEB_HOST_ARCH_OS	:= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_CPU	:= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_TYPE	:= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	:= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR_LIBSEPOL		:= $(shell pkg-config --variable=libdir libsepol)

# for cross compilation
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  PREFIX = /usr
else
  PREFIX = /usr/$(DEB_HOST_GNU_TYPE)
endif

## Default target
binary:

## Sanity check
ifneq ($(DEB_HOST_ARCH_OS),linux)
$(error This is a linux only package. Aborting build.)
endif

## Unconditionally run debhelper command targets
.PHONY: FORCE
FORCE:

## By default, pass everything through debhelper automatically
export DH_OPTIONS
%: FORCE
	@dh $@ --with=python2,ruby

## Don't try to rebuild the debian/rules file
debian/rules:
	@touch $@

## Skip python/ruby packages during stage1 build
ifeq ($(DEB_STAGE),stage1)
DH_OPTIONS += -Npython-selinux -Nruby-selinux -Nlibselinux-ruby1.8
endif

## Set up some variables to be passed to the upstream Makefile
extra_make_args  = LIBSEPOLDIR=$(LIBDIR_LIBSEPOL)
extra_make_args += ARCH=$(DEB_HOST_GNU_CPU)
extra_make_args += CC=$(DEB_HOST_GNU_TYPE)-gcc
override_dh_auto_build: FORCE
	+$(MAKE) PREFIX="$(PREFIX)" $(extra_make_args) all

## Work around the very limited SELinux build-system
DESTDIR = $(CURDIR)/debian/tmp
extra_install_args  = $(extra_make_args)
extra_install_args += DESTDIR=$(DESTDIR)
extra_install_args += LIBDIR=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
extra_install_args += SHLIBDIR=$(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_install: FORCE
	+$(MAKE) PREFIX="$(DESTDIR)$(PREFIX)" $(extra_install_args) install
	@# Fix up the broken library symlink
	rm -f $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
	mkdir $(DESTDIR)/selinux
	ln -s /lib/$(DEB_HOST_MULTIARCH)/libselinux.so.1 $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
	@# Move manpages for user-accessible tools to section 1
	install -d -m 755 $(DESTDIR)/usr/share/man/man1
	mv $(DESTDIR)/usr/share/man/man8/getenforce.8     $(DESTDIR)/usr/share/man/man1/getenforce.1
	mv $(DESTDIR)/usr/share/man/man8/selinuxenabled.8 $(DESTDIR)/usr/share/man/man1/selinuxenabled.1
ifneq ($(DEB_STAGE),stage1)
	+$(MAKE) PREFIX="$(PREFIX)" $(extra_install_args) -f debian/python.mk
	+$(MAKE) PREFIX="$(PREFIX)" $(extra_install_args) -f debian/ruby.mk
else
	@echo "Detected stage-1 bootstrap, skipping python/ruby bindings..."
endif

## Generate a hard error for any upstream files we don't install
override_dh_install: FORCE
	dh_install --fail-missing
